      subroutine screen
      include <windows.ins>
      common /c_buffer/ nbytes,nrecs,info(24),buffer(400)
         character buffer*104
      common /c_values/ iseason,lhour,month,ihour,freq,xnoise,rlat,rlon
      common /x_values/ iseasonx,lhourx,freqx,noisex,rlatx,rlonx
         real*8 freqx,rlatx,rlonx
      common /c_noise/ mode_n1,mode_n2,mode_n3
      common /c_season/ mode_s1,mode_s2
      common /c_limit/ mode_l1,mode_l2,mode_l3,mode_l4
      common /s_strings/ s_galactic,s_manmade
         character s_galactic*20,s_manmade*20
      external singleCB,saveCB,viewCB,gridCB,HELP,how_to_run
      external about,updateCB,limit1,limit2,limit3,limit4
      external atmospheric,galactic,manmade,season1,season2
      character LF*1,WHITE*11,alf*104
      character seasons(4)*12,timeblocks(6)*12
      data seasons/'1=Winter','2=Spring','3=Summer','4=Autumn'/
      data timeblocks/'1=0000-0400','2=0400-0800','3=0800-1200',
     +                '4=1200-1600','5=1600-2000','6=2000-2400'/
      data WHITE/'%`bg[WHITE]'/     !  make next field WHITE
      LF=char(10)
      open(21,file='gh_noise.dat',status='old',err=900)
      rewind(21)
      read(21,*,err=900) iseason,lhour,freq,xnoise,rlat,rlon
      close(21)
      mode_n1=1      !  turn on atmospheric noise
      mode_n2=1      !  turn on galactic    noise
      mode_n3=1      !  turn on man-made    noise
      mode_s1=0      !  normal equator
      mode_s2=1      !  interpolate near equator
      mode_l1=1      !  Modified Spaulding method
      mode_l2=0      !  log-normal sum limit DU & DL to 12dB
      mode_l3=0      !  log-normal sum no DU/DL limits
      mode_l4=0      !  old power sum
10    iseasonx=iseason
      lhourx=lhour
      freqx=freq
      noisex=xnoise
      rlatx=rlat
      rlonx=rlon

      lenx=GetSystemMetrics(SM_CXSCREEN)    !  how big is screen
      k=WINIO@('%ca[GH_NOISE - Proposed correction to '//
     +   'Recommendation ITU-R P372-8 - Combination of Radio Noise]&')
      k=winio@('%mn[E&xit]&','EXIT')
      k=winio@('%mn[&Worldmap]&',gridCB)

      k=winio@(
     +  '%mn[&Noise source[#&Atmospheric,#&Galactic,#&Man-made]]&',
     +           mode_n1,atmospheric,
     +           mode_n2,galactic,
     +           mode_n3,manmade)
      k=winio@('%mn[&Equator[#&Interpolate,#&Normal]]&',
     +           mode_s2,season2,
     +           mode_s1,season1)
      k=winio@('%mn[&Power Sum'//
     +         '[#&Modified Spaulding,'//
ccc     +          '#&Limit DU/DL to 12dB,'//
     +          '#&Weighted Power Sum,'//
     +          '#&Simple Power Sum]]&',
     +           mode_l1,limit1,
ccc     +           mode_l2,limit2,
     +           mode_l3,limit3,
     +           mode_l4,limit4)

      k=WINIO@('%mn[&Help[&View Help.txt,&View Examples.txt,'//
     +     '|,&About GH_NOISE]]&',
     +     HELP,how_to_run,about)
      if(lenx.le.640) then       !  for smaller screen, use MAXIMISE
         k=WINIO@('%ww[MAXIMISE]&')
      else
         k=WINIO@('%ww[no_maxbox]&')
      end if
ccc      call backgrnd         !  set the background color of the window 
      k=WINIO@('Modify the NOISE parameters:&')
      k=winio@('%ta%ta%bf%^?tt[Single]['//
     +   'Calculate noise for 1 location.'//LF//
     +   'Display results in OUTPUT window.]&',
     +         singleCB)
      k=winio@('%ta%^?tt[Save]['//
     +   'Calculate noise for 1 location.'//LF//
     +   'Display results in OUTPUT window.'//LF//
     +   'Save results to GH_NOISE.TXT file.]&',
     +         saveCB)
      k=winio@('%ta%^?tt[View]['//
     +   'View results currently in GH_NOISE.TXT file.]&',
     +         viewCB)

      k=WINIO@('%`bf%nl%nl'//WHITE//'%`?lb@'//
     +   ' =Season&',seasons,4,iseasonx,
     +   'Specify the SEASON. '//
     +    '(Noise results vary by season NOT by month.)'//LF//
     +    ' Winter = Dec,Jan,Feb'//LF//
     +    ' Spring = Mar,Apr,May'//LF//
     +    ' Summer = Jun,Jul,Aug'//LF//
     +    ' Autumn = Sep,Oct,Nov'//LF//
     +    'These are definitions for the Northern Hemisphere.')

      k=WINIO@('%nl'//WHITE//'%`?lb@'//
     +   ' =Local Time block&',timeblocks,6,lhourx,
     +   'Specify the Local TIME block.')

      k=winio@('%ta%ta%ta%ta%ta%bf%^?tt[Update]['//
     +   'Update the Frequency contribution for'//LF//
     +   'Galactic and Man-Made noise.]%`bf&',
     +         updateCB)
      k=winio@('%nl%sf&')

      k=WINIO@('%nl%fl'//WHITE//'%8?rf@'//
     +   '  =Frequency (.01-30 MHz)&',
     +         0.D0,30.D0,freqx,
     +   'Specify the FREQUENCY in MHz.'//LF//
     +    ' '//LF//
     +    'Range (.01-30 MHz)')
c**************************************************************
      call set_galactic
      k=winio@('%ta%tc[red]%ta%bf%20st%`bf&',s_galactic)
      call set_manmade
      k=winio@('%ta%bf%20st%`bf%tc[black]&',s_manmade)
c**************************************************************

      k=WINIO@('%nl%il'//WHITE//'%8?rd@'//
     +'  =Man-Made Noise level at 3 MHz (-dBw/Hz) in a 1 Hz bandwidth&',
     +         1,200,noisex,
     +   'Man-made noise level at 3 MHz in -dBw/Hz '//
     +   '(dB below a Watt)'//LF//
     +   '      1 = 140.42 = industrial'//LF//
     +   '      2 = 144.72 = residential'//LF//
     +   '      3 = 150.02 = rural'//LF//
     +   '      4 = 163.62 = remote'//LF//
     +   'Other values are specified in the range (100-200).'//LF//
     +   'From CCIR Report 258.    '//
     +   'Default = -145 dBw/Hz')

      k=WINIO@('%nl%fl'//WHITE//'%8?rf@'//
     +   '  =Latitude&',
     +         -90.D0,90.D0,rlatx,
     +   'Specify the LATITUDE in decimal degrees.'//LF//
     +    ' '//LF//
     +    'Range (-90 to 90 degrees)')

      k=WINIO@('%nl%fl'//WHITE//'%8?rf@'//
     +   '  =Longitude&',
     +         -180.D0,180.D0,rlonx,
     +   'Specify the LONGITUDE in decimal degrees.'//LF//
     +    ' '//LF//
     +    'Range (-180 to 180 degrees)')

      k=WINIO@('%nl%obInput Help: %tc%he%cb%nl%nl%nl%nl%nl%nl&',
     +           RGB@(255,0,0))
ccc      buffer(1)='Output from SINGLE and SAVE will appear here.'//
ccc     +          char(13)//char(10)//char(0)
      nbytes=0
      nrecs=0
      k=winio@('%nl%nl%tc[Black]&')
      k=winio@('%fn[Courier New]%ts&',.8d0)
      k=winio@('%102.10`?eb[vscrollbar,read_only]@',
     +      buffer,nbytes,info,
     + 'Output from SINGLE and SAVE will appear in this window.')
ccc      write(alf,1)
ccc1     format('Month   UT FreqMHz   MMN  Latitude Longitude',
ccc     +'    NdBW     Fam      DL      DU SigmaLW  SigmaN SigmaUP')
ccc      alf='Output from SINGLE and SAVE will appear here.'
ccc      alf(101:103)=char(13)//char(10)//char(0)
ccc      call next_edit_operation@(info)
ccc      call edit_move_home@(info)
ccc      call edit_move_bof@(info)
ccc      call insert_edit_string@(info,alf)
ccc      call window_update@(info)
ccc      nbytes=102
      return
900   iseason=3
      lhour=1
      freq=6.09
      xnoise=145.
      rlat=40.
      rlon=-105.
      go to 10
      end
c-----------------------------------------------------------------
      integer*4 function singleCB()
      include <windows.ins>
      common /c_buffer/ nbytes,nrecs,info(24),buffer(400)
         character buffer*104
      common /c_values/ iseason,lhour,month,ihour,freq,xnoise,rlat,rlon
      common /x_values/ iseasonx,lhourx,freqx,noisex,rlatx,rlonx
         real*8 freqx,rlatx,rlonx
      common /r_noise/ cnoise,xdu,xdl,xsigm,xsygu,xsygl
      common /c_noises/ xn_atnos,xn_galactic,xn_mmn
      common /c_noise/ mode_n1,mode_n2,mode_n3
      common /c_season/ mode_s1,mode_s2
      common /c_limit/ mode_l1,mode_l2,mode_l3,mode_l4
      common /s_strings/ s_galactic,s_manmade
         character s_galactic*20,s_manmade*20
      character equ*1
      character alf*104
      character noise_alf(3)*2
      dimension val_noise(4)
      character psum(4)*1,codes*5,psuma*1
      data psum/'m','l','w','s'/
      data val_noise/140.4,144.7,150.0,163.6/
      data noise_alf/' A',' G',' M'/

      if(noisex.gt.4 .and. noisex.lt.100) go to 900
      if(freqx.lt..009999) go to 910
      if(mode_n1+mode_n2+mode_n3.eq.0) go to 920

      iseason=iseasonx
      if(iseason.eq.1) month=1        !  winter=Jan
      if(iseason.eq.2) month=4        !  spring=Apr
      if(iseason.eq.3) month=7        !  summer=Jul
      if(iseason.eq.4) month=10       !  autumn=Oct
      lhour=lhourx
      ihour=lhour          !  temp local time
      freq=freqx
      xnoise=noisex
      rlat=rlatx
      rlon=rlonx
      call set_galactic
      call window_update@(s_galactic)
      call set_manmade
      call window_update@(s_manmade)
      call single(0,month,ihour,freq,xnoise,rlat,rlon)
      if(mod(nrecs,10).eq.0) then
         write(alf,1)
1        format('      Se TB FreqMHz   MMN  Latitude Longitude',
     +   '    NdBW     Fam      DL      DU SignaLW  SigmaN SigmaUP')
ccc     +   '     Fam')
         alf(102:104)=char(13)//char(10)//char(0)
         call edit_move_bof@(info)
         call insert_edit_string@(info,alf)
         nrecs=nrecs+1
      end if
      vnoise=noisex
      if(noisex.le.4) vnoise=val_noise(noisex)
      equ='n'     !  no equator interpolation
      if(mode_s2.eq.1) equ='i'    !  equator interpolate
      psuma=psum(1)
      if(mode_l2.eq.1) psuma=psum(2)
      if(mode_l3.eq.1) psuma=psum(3)
      if(mode_l4.eq.1) psuma=psum(4)
      write(codes,'(5a1)') noise_alf(1)(mode_n1+1:mode_n1+1),
     +               noise_alf(2)(mode_n2+1:mode_n2+1),
     +               noise_alf(3)(mode_n3+1:mode_n3+1),equ,
     +               psuma
  
      write(alf,101) codes,
     +            iseason,lhour,freq,vnoise,rlat,rlon,
     +            cnoise,cnoise+204.,xdl,xdu,xsygl,xsigm,xsygu
ccc     +            xn_atnos+204.
101   format(a5,2i3,f8.3,f6.1,2f10.4,8f8.2)
      nrecs=nrecs+1
      alf(102:104)=char(13)//char(10)//char(0)
      call edit_move_bof@(info)
      call insert_edit_string@(info,alf)
      go to 999
900   k=winio@('%ca[Input ERROR]%bg[RED]'//
     +            '%cn%`bt[Noise MUST be in range (1-4 or 100-200)]')
      go to 999
910   k=winio@('%ca[Input ERROR]%bg[RED]'//
     +            '%cn%`bt[Frequency MUST be in range (.01-30 MHz)]')
      go to 999
920   k=winio@('%ca[Input ERROR]%bg[RED]'//
     +         '%cn%`bt[At least 1 NOISE source must be selected.]')
999   singleCB=1
      return
      end
c-----------------------------------------------------------------
      integer*4 function gridCB()
      common /c_values/ iseason,lhour,month,ihour,freq,xnoise,rlat,rlon
      common /x_values/ iseasonx,lhourx,freqx,noisex,rlatx,rlonx
         real*8 freqx,rlatx,rlonx
      common /r_noise/ cnoise,xdu,xdl,xsigm,xsygu,xsygl
      common /c_noise/ mode_n1,mode_n2,mode_n3
      common /s_strings/ s_galactic,s_manmade
         character s_galactic*20,s_manmade*20
      character alf*200,fileout*20
      data fileout/'noise_grid.txt'/

      if(noisex.gt.4 .and. noisex.lt.100) go to 900
      if(freqx.lt..009999) go to 910
      if(mode_n1+mode_n2+mode_n3.eq.0) go to 920

      iseason=iseasonx
      if(iseason.eq.1) month=1        !  winter=Jan
      if(iseason.eq.2) month=4        !  spring=Apr
      if(iseason.eq.3) month=7        !  summer=Jul
      if(iseason.eq.4) month=10       !  autumn=Oct
      lhour=lhourx
      ihour=lhour          !  temp local time

      freq=freqx
      xnoise=noisex
      rlat=rlatx
      rlon=rlonx
      call set_galactic
      call window_update@(s_galactic)
      call set_manmade
      call window_update@(s_manmade)
ccc      open(22,file='worldmap.dat')
ccc      rewind(22)
ccc      write(22,1) month,ihour,freq,xnoise
ccc1     format(2i5,f8.3,f7.1)
ccc      close(22)
      luout=22
      open(luout,file=fileout)
      rewind(luout)
      CALL grid(luout,month,ihour,freq,xnoise)
      close(luout)
      alf='worldmap.exe '//fileout
      nch=lenchar(alf)
      call gh_exec(alf,nch,0)
      go to 999
900   k=winio@('%ca[Input ERROR]%bg[RED]'//
     +            '%cn%`bt[Noise MUST be in range (1-4 or 100-200)]')
      go to 999
910   k=winio@('%ca[Input ERROR]%bg[RED]'//
     +            '%cn%`bt[Frequency MUST be in range (.01-30 MHz)]')
      go to 999
920   k=winio@('%ca[Input ERROR]%bg[RED]'//
     +         '%cn%`bt[At least 1 NOISE source must be selected.]')
999   gridCB=1
      return
      end
c-----------------------------------------------------------------
      integer*4 function HELP()
      call gh_exec('notepad database\help.txt',25,0)
      HELP=1
      return
      end
c-----------------------------------------------------------------
      integer*4 function how_to_run()
      call gh_exec('notepad database\examples.txt',29,0)
      how_to_run=1
      return
      end
c-----------------------------------------------------------------
      integer*4 function saveCB()
      include <windows.ins>
      common /c_buffer/ nbytes,nrecs,info(24),buffer(400)
         character buffer*104
      common /c_values/ iseason,lhour,month,ihour,freq,xnoise,rlat,rlon
      common /x_values/ iseasonx,lhourx,freqx,noisex,rlatx,rlonx
         real*8 freqx,rlatx,rlonx
      common /r_noise/ cnoise,xdu,xdl,xsigm,xsygu,xsygl
      common /c_noises/ xn_atnos,xn_galactic,xn_mmn
      common /c_noise/ mode_n1,mode_n2,mode_n3
      common /c_season/ mode_s1,mode_s2
      common /c_limit/ mode_l1,mode_l2,mode_l3,mode_l4
      common /s_strings/ s_galactic,s_manmade
         character s_galactic*20,s_manmade*20
      character equ*1
      character alf*104
      character noise_alf(3)*2
      dimension val_noise(4)
      character psum(4)*1,codes*5,psuma*1
      data psum/'m','l','w','s'/
      data val_noise/140.4,144.7,150.0,163.6/
      data noise_alf/' A',' G',' M'/

      if(noisex.gt.4 .and. noisex.lt.100) go to 900
      if(freqx.lt..009999) go to 910
      if(mode_n1+mode_n2+mode_n3.eq.0) go to 920

      iseason=iseasonx
      if(iseason.eq.1) month=1        !  winter=Jan
      if(iseason.eq.2) month=4        !  spring=Apr
      if(iseason.eq.3) month=7        !  summer=Jul
      if(iseason.eq.4) month=10       !  autumn=Oct
      lhour=lhourx
      ihour=lhour          !  temp local time

      freq=freqx
      xnoise=noisex
      rlat=rlatx
      rlon=rlonx
      call set_galactic
      call window_update@(s_galactic)
      call set_manmade
      call window_update@(s_manmade)
      call single(0,month,ihour,freq,xnoise,rlat,rlon)
      if(mod(nrecs,10).eq.0) then
         write(alf,1)
1        format('      Se TB FreqMHz   MMN  Latitude Longitude',
     +   '    NdBW     Fam      DL      DU SigmaLW  SigmaN SigmaUP')
ccc     +   '     Fam')
         alf(101:103)=char(13)//char(10)//char(0)
         call edit_move_bof@(info)
         call insert_edit_string@(info,alf)
         nrecs=nrecs+1
      end if
      vnoise=noisex
      if(noisex.le.4) vnoise=val_noise(noisex)
      equ=' '
      if(mode_s2.eq.1) equ='i'    !  equator interpolate
      if(mode_s2.eq.1) equ='i'    !  equator interpolate
      psuma=psum(1)
      if(mode_l2.eq.1) psuma=psum(2)
      if(mode_l3.eq.1) psuma=psum(3)
      if(mode_l4.eq.1) psuma=psum(4)
      write(codes,'(5a1)') noise_alf(1)(mode_n1+1:mode_n1+1),
     +               noise_alf(2)(mode_n2+1:mode_n2+1),
     +               noise_alf(3)(mode_n3+1:mode_n3+1),equ,
     +               psuma
      write(alf,101) codes,
     +               iseason,lhour,freq,vnoise,rlat,rlon,
     +   cnoise,cnoise+204.,xdl,xdu,xsygl,xsigm,xsygu!xn_atnos+204.
      nrecs=nrecs+1
      alf(102:104)=char(13)//char(10)//char(0)
      call edit_move_bof@(info)
      call insert_edit_string@(info,alf)
      open(21,file='gh_noise.txt',status='append')
      write(21,101) codes,
     +               iseason,lhour,freq,vnoise,rlat,rlon,
     + cnoise,cnoise+204.,xdl,xdu,xsygl,xsigm,xsygu!xn_atnos+204.
101   format(a5,2i3,f8.3,f6.1,2f10.4,8f8.2)
      close(21)
      go to 999
900   k=winio@('%ca[Input ERROR]%bg[RED]'//
     +            '%cn%`bt[Noise MUST be in range (1-4 or 100-200)]')
      go to 999
910   k=winio@('%ca[Input ERROR]%bg[RED]'//
     +            '%cn%`bt[Frequency MUST be in range (.01-30 MHz)]')
      go to 999
920   k=winio@('%ca[Input ERROR]%bg[RED]'//
     +         '%cn%`bt[At least 1 NOISE source must be selected.]')
999   saveCB=1
      return
      end
c-----------------------------------------------------------------
      integer*4 function viewCB()
      call gh_exec('notepad gh_noise.txt',20,0)
      viewCB=1
      return
      end
c-----------------------------------------------------------------
      integer*4 function atmospheric()   !  switch atmospheric flag
      common /c_noise/ mode_n1,mode_n2,mode_n3
      mode_n1=1-mode_n1
      atmospheric=1
      return
      end
c----------------------------------------------------------------
      integer*4 function galactic()   !  switch galactic flag
      common /c_noise/ mode_n1,mode_n2,mode_n3
      mode_n2=1-mode_n2
      galactic=1
      return
      end
c----------------------------------------------------------------
      integer*4 function manmade()   !  switch manmade flag
      common /c_noise/ mode_n1,mode_n2,mode_n3
      mode_n3=1-mode_n3
      manmade=1
      return
      end
c----------------------------------------------------------------
      integer*4 function season1()   !  normal season
      common /c_season/ mode_s1,mode_s2
      mode_s1=1
      mode_s2=0
      season1=1
      return
      end
c----------------------------------------------------------------
      integer*4 function season2()   !  swap season in south
      common /c_season/ mode_s1,mode_s2
      mode_s1=0
      mode_s2=1
      season2=1
      return
      end
c----------------------------------------------------------------
      integer*4 function limit 1()  ! modified Spaulding method
      common /c_limit/ mode_l1,mode_l2,mode_l3,mode_l4
      mode_l1=1
      mode_l2=0
      mode_l3=0
      mode_l4=0
      limit1=1
      return
      end
c----------------------------------------------------------------
      integer*4 function limit 2()  ! log-normal limit DU & DL to 12dB
      common /c_limit/ mode_l1,mode_l2,mode_l3,mode_l4
      mode_l1=0
      mode_l2=1
      mode_l3=0
      mode_l4=0
      limit2=1
      return
      end
c----------------------------------------------------------------
      integer*4 function limit 3()  ! log-normal no limit for DU & DL
      common /c_limit/ mode_l1,mode_l2,mode_l3,mode_l4
      mode_l1=0
      mode_l2=0
      mode_l3=1
      mode_l4=0
      limit3=1
      return
      end
c----------------------------------------------------------------
      integer*4 function limit 4()  ! old power sum
      common /c_limit/ mode_l1,mode_l2,mode_l3,mode_l4
      mode_l1=0
      mode_l2=0
      mode_l3=0
      mode_l4=1
      limit4=1
      return
      end
c----------------------------------------------------------------
      integer*4 function updateCB()   ! 
      include <windows.ins>
      common /s_strings/ s_galactic,s_manmade
         character s_galactic*20,s_manmade*20
      common /c_values/ iseason,lhour,month,ihour,freq,xnoise,rlat,rlon
      common /x_values/ iseasonx,lhourx,freqx,noisex,rlatx,rlonx
         real*8 freqx,rlatx,rlonx

      if(noisex.gt.4 .and. noisex.lt.100) go to 900
      if(freqx.lt..009999) go to 910
      freq=freqx
      xnoise=noisex
      call set_galactic
      call window_update@(s_galactic)
      call set_manmade
      call window_update@(s_manmade)
      updateCB=1
      return
900   k=winio@('%ca[Input ERROR]%bg[RED]'//
     +            '%cn%`bt[Noise MUST be in range (1-4 or 100-200)]')
      go to 999
910   k=winio@('%ca[Input ERROR]%bg[RED]'//
     +            '%cn%`bt[Frequency MUST be in range (.01-30 MHz)]')
999   updateCB=1
      return
      end
c----------------------------------------------------------------
      subroutine set_galactic  !  set galactic noise value
      common /c_values/ iseason,lhour,month,ihour,freq,xnoise,rlat,rlon
      common /s_strings/ s_galactic,s_manmade
         character s_galactic*20,s_manmade*20
      gnos=52. - 23.*alog10(freq)
      write(s_galactic,1) gnos
1     format('Galactic =',f8.2,'dB')
      return
      end
c----------------------------------------------------------------
      subroutine set_manmade   !  set manmade  noise value
      common /c_values/ iseason,lhour,month,ihour,freq,xnoise,rlat,rlon
      common /s_strings/ s_galactic,s_manmade
         character s_galactic*20,s_manmade*20
      DIMENSION XNINT(4)     !  .....MAN-MADE NOISE LEVELS
      DATA XNINT /76.8, 72.5, 67.2, 53.6/
      MAN=xNOISE
C
C     MAN MADE NOISE
C
      if(man.le.4) man=-man   !  for index 1,2,3,4
      XNOIS=MAN
      MA=IABS(MAN)
      ZNOISE=XNOIS
      IF (MAN) 120,114,115
C.....INDICATES -164 ON USER INPUT
  114 MA=4
      GO TO 120
C.....CONVERT 3 MHZ DB .LT. 1 WATT INPUT VALUE TO FA AT 1 MHZ
  115 XNOIS=204.0-XNOIS+13.22
C.....OBTAIN FA AT DESIRED FREQUENCY
      XNOIS=XNOIS-27.7*ALOG10(FREQ)
      GO TO 125
C.....NEGATIVE ON USER INPUT INDICATES INDEX
  120 MA=MIN0(4,MA)
      CONN=27.7
ccc      IF (MA.EQ.4) CONN=28.6
      XNOIS=XNINT(MA)-CONN*ALOG10(FREQ)
      ZNOISE=204.0-XNINT(MA)+13.22
125   continue
      write(s_manmade ,1) xnois
1     format('Man-made =',f8.2,'dB')
      return
      end
c----------------------------------------------------------------
