C---------------------------------------------------------------------
        SUBROUTINE CFIND(CONT,NCONT,LU,NFOUND,FORMAT,idigits)
      parameter (NGRID_DIM=361)
C****************************************************************** 
C          Written by Greg Hand
C               Originally for NAVAIR ~1976
C               Modified for BLM ~1981
C               Currently for NTIA/ITS 1983+
C               Current documentation 3/21/88
C          Contact Greg Hand NTIA/ITS.S4
C                  325 Broadway
C                  Boulder, Colorado 80303
C                  (303)497-3375
C                  (FTS)320-3375
C****************************************************************** 
C          CONT = array of values to contour 
C          NCONT = number of values in CONT
C          LU = unit number to write contour (x,y) coordinates to
C             = 0 = plot immediately
C                  (Must be OPENed in calling routine)
C          NFOUND = number of contour lines found
C          FORMAT = CHARACTER string specifying the format to output
C                   the (x,y) coordinates. e.g. '(5(F8.1,F7.1))'
c          idigits= 0 = integer labels
c                 = i = f8.i format
C          User must all fill the COMMON blocks /GRID/ & /RUNDATA/
C****************************************************************** 
C                            LASTIN           Box corners are indices
C                               3             into ZA array. Corner #2
C                               !             is (LASTX,LASTY).
C                               !
C                        3**************4
C                        *    Cell      *
C                        *  definition  *
C           LASTIN=2>>>>>*              *<<<<<4=LASTIN
C                        *              *
C                        *              *
C                        2**************1/5
C                               ^
C                               ^
C                               1
C                            LASTIN
C****************************************************************** 
      COMMON /GRID/ GRID(NGRID_DIM,NGRID_DIM)  
      COMMON /GRIDF/ IGRIDF(NGRID_DIM,NGRID_DIM)
        COMMON /RUNDATA/ XMIN,YMIN,DXC,DYC,NX,NY
C                        (XMIN,YMIN) - (x,y) value at GRID(1,1)
C                        DXC - X cell size =(XMAX-XMIN)/(NX-1)
C                        DYC - Y cell size =(YMAX-YMIN)/(NY-1)
C                        NX,NY - number of cells in x & y
        DIMENSION CONT(*),Z(5)   
        CHARACTER FORMAT*(*)
C
      NFOUND=0
      DO 500 IOFF=0,NCONT-1,8   
      NC=8
      IF(NC+IOFF.GT.NCONT) NC=NCONT-IOFF
C
C          With NX*NY grid points, there are (NX-1)*(NY-1) cells.
C          In each cell set a bit flag identifying if a given contour
C          level passes thru this cell.
C          This code assumes a 16-bit word length. Which allows only
C          8 contours per pass.
        DO 100 IY=2,NY
        Z(1)=GRID(1,IY-1) 
        Z(4)=GRID(1,IY) 
        DO 100 IX=2,NX
        ICROSS=0
        Z(2)=Z(1) 
        Z(3)=Z(4) 
        Z(1)=GRID(IX  ,IY-1) 
        Z(5)=Z(1) 
        Z(4)=GRID(IX  ,IY) 
        ZLOW=AMIN1(Z(1),Z(2),Z(3),Z(4))
        IF(ZLOW.LT.-32000.) GO TO 90         
        DO 20 IC=1,NC 
ccc        C=CONT(IC+IOFF)*.9999
        C=CONT(IC+IOFF)
        MASK=2**(IC-1)
        NT=0
        DO 10 I=1,4 
        IF((C.GE.Z(I) .AND. C.LT.Z(I+1)) .OR. 
     +     (C.GE.Z(I+1) .AND. C.LT.Z(I))    ) NT=NT+1 
 10     CONTINUE
        IF(NT.GE.2) ICROSS=IOR(ICROSS,MASK) 
C          IF BOX HAS 4 ENTRANCES/EXITS, PUT IN UPPER HALF OF WORD
        IF(NT.EQ.4) ICROSS=IOR(ICROSS,LS(MASK,8))
 20     CONTINUE
 90     IGRIDF(IX-1,IY-1)=ICROSS 
 100    CONTINUE
C          Begin searching for contour values
C          Search for entry along BOTTOM
        CALL CONFIND(LU,NFOUND,2,NX,2,2,1,CONT(IOFF+1),NC,IOFF,  
     +                  FORMAT,idigits)
C          Search for entry along LEFT SIDE
        CALL CONFIND(LU,NFOUND,2,2,3,NY,2,CONT(IOFF+1),NC,IOFF,   
     +                  FORMAT,idigits)
C          Search for entry along TOP
        CALL CONFIND(LU,NFOUND,2,NX,NY,NY,3,CONT(IOFF+1),NC,IOFF,  
     +                  FORMAT,idigits)
C          Search for entry along RIGHT SIDE
        CALL CONFIND(LU,NFOUND,NX,NX,3,NY,4,CONT(IOFF+1),NC,IOFF,   
     +                  FORMAT,idigits)
C          Satisfy all internal cells not yet searched
        CALL CONFIND(LU,NFOUND,3,NX-1,3,NY-1,0,CONT(IOFF+1),NC,IOFF,   
     +                  FORMAT,idigits)
500   CONTINUE
        RETURN
        END 
C------------------------------------------------------------------
      SUBROUTINE CONFIND(LU,NFOUND,LOWX,IHIX,LOWY,IHIY,INLAST,
     +                   CONT,NCONT,IOFF,FORMAT,idigits)
      parameter (NGRID_DIM=361)
      COMMON /GRID/ GRID(NGRID_DIM,NGRID_DIM)
      COMMON /GRIDF/ IGRIDF(NGRID_DIM,NGRID_DIM)
      COMMON /XYVAL/ X(5000),Y(5000)
      COMMON /GHPARMS/ Z,ZA(5),LASTX,LASTY,NEXTX,NEXTY,LASTIN,LASTOT
      COMMON /RUNDATA/ XMIN,YMIN,DXC,DYC,NX,NY 
      DIMENSION CONT(*) 
      CHARACTER FORMAT*(*)
	character labl*8
      DATA BAD/-32000./      
C                            !  Any Z value < BAD is ignored
      DATA MAXDIM/5000/      
C 
      XMAX=XMIN + FLOAT(NX-1)*DXC          
      YMAX=YMIN + FLOAT(NY-1)*DYC          
        DO 1000 IYY=LOWY,IHIY
        DO 1000 IXX=LOWX,IHIX
        IY=IYY-1 
        IX=IXX-1
        IF(INLAST.EQ.0) GO TO 450 
 50     V1=GRID(IX,IY) 
        V2=GRID(IX+1,IY) 
        V3=GRID(IX  ,IY+1) 
        V4=GRID(IX+1,IY+1) 
        IF(V1.GT.BAD .AND. V2.GT.BAD .AND.  
     +            V3.GT.BAD .AND. V4.GT.BAD) GO TO 450  
C          BAD DATA PART OF SQUARE
        GO TO (100,200,300,400),INLAST
 100    IF(V1.GT.BAD .AND. V4.GT.BAD) GO TO 1000
        IY=IY+1 
        IF(V2.LT.BAD .OR. V3.LT.BAD) IY=IY+1
        IF(IY.GE.NY) GO TO 1000 
        GO TO 50
 200    IF(V1.GT.BAD .AND. V2.GT.BAD) GO TO 1000
        IX=IX+1 
        IF(V3.LT.BAD .OR. V4.LT.BAD) IX=IX+1
        IF(IX.GE.NX) GO TO 1000 
        GO TO 50
 300    IF(V2.GT.BAD .AND. V3.GT.BAD) GO TO 1000
        IY=IY-1 
        IF(V1.LT.BAD .OR. V4.LT.BAD) IY=IY-1
        IF(IY.LE.1) GO TO 1000
        GO TO 50
 400    IF(V3.GT.BAD .AND. V4.GT.BAD) GO TO 1000
        IX=IX-1 
        IF(V1.LT.BAD .OR. V2.LT.BAD) IX=IX-1
        IF(IX.LE.1) GO TO 1000 
        GO TO 50
 450    DO 900 IC=1,NCONT
        IDF=IGRIDF(IX,IY)
        IF(IDF.EQ.0) GO TO 1000 
        MASK=2**(IC-1) 
        IF(IAND(IDF,MASK).EQ.0) GO TO 900 
ccc        Z=CONT(IC)*.9999
        Z=CONT(IC)
        NEXTX=IX 
        NEXTY=IY 
        LASTOT=INLAST 
        NUM=0 
 500    NUM=NUM+1 
        LASTX=NEXTX 
        LASTY=NEXTY 
        LASTIN=LASTOT 
        IF(LASTY.NE.0 .AND. LASTX.LT.NX) ZA(1)=GRID(LASTX+1,LASTY  ) 
        IF(LASTY.NE.0 .AND. LASTX.NE.0)  ZA(2)=GRID(LASTX  ,LASTY  )  
        IF(LASTX.NE.0 .AND. LASTY.LT.NY) ZA(3)=GRID(LASTX  ,LASTY+1) 
        IF(LASTX.LT.NX .AND. LASTY.LT.NY)ZA(4)=GRID(LASTX+1,LASTY+1)
        ZLOW=AMIN1(ZA(1),ZA(2),ZA(3),ZA(4))
        ZA(5)=ZA(1) 
        IF(ZLOW.GT.BAD) GO TO 525  
C          STOPPED SEARCH BECAUSE BOX ENCOUNTERED WITH BAD POINT IN IT
        IF(NUM.EQ.1) GO TO 900     
        NUM=NUM-1 
        GO TO 700 
C          CONTINUE SEARCH
 525    IF(NUM.GT.1) GO TO 600
        IF(LASTIN.NE.0) GO TO 590 
C          IF LASTIN IS 0, FIND OUT HOW TO ENTER BOX
        DO 550 LASTIN=1,4 
        ZLOW=AMIN1(ZA(LASTIN),ZA(LASTIN+1))
        ZHI =AMAX1(ZA(LASTIN),ZA(LASTIN+1))
        IF(ZLOW.LE.Z .AND. Z.LT.ZHI) GO TO 600
 550    CONTINUE
        GO TO 900 
 590    ZLOW=AMIN1(ZA(INLAST+1),ZA(INLAST))
        ZHI =AMAX1(ZA(INLAST+1),ZA(INLAST))
        IF(ZLOW.GT.Z .OR. Z.GE.ZHI) GO TO 900 
 600    CALL GETXY(XNUM,YNUM) 
      LXLAST=LASTX
      LYLAST=LASTY
      IF(XNUM.GT.XMAX) XNUM=XMAX
      IF(YNUM.GT.YMAX) YNUM=YMAX
        X(NUM)=XNUM 
        Y(NUM)=YNUM 
        IGF=0 
        IF(LASTX.LT.NX .AND. LASTY.LT.NY .and.
     +     LASTX.GT. 0 .AND. LASTY.GT. 0)IGF=IGRIDF(LASTX,LASTY)
        IDF=IGF 
        NXP=NEXTPT(IDF,MASK,INLAST,NUM) 
        IF(IGF.NE.IDF) IGRIDF(LASTX,LASTY)=IDF  
        IF(NUM.EQ.MAXDIM-1) GO TO 700     
        IF(NUM.GT.1 .AND. X(NUM).EQ.X(1) .AND. Y(NUM).EQ.Y(1)) GO TO 700
        IF(NXP) 625,700,500 
 625    CONTINUE
        XNUM=X(NUM) 
        YNUM=Y(NUM) 
        IF(LASTY.GE.NY) YNUM=YMAX
        IF(LASTX.GE.NX) XNUM=XMAX
        IF(LASTX.EQ.0) XNUM=XMIN 
        IF(LASTY.EQ.0) YNUM=YMIN 
      IF(XNUM.EQ.X(NUM) .AND. YNUM.EQ.Y(NUM)) GO TO 700
        NUM=NUM+1
        X(NUM)=XNUM 
        Y(NUM)=YNUM 
 700    CONTINUE
        IF(NUM.EQ.1) GO TO 900      
C********************************************************************** 
C          OUTPUT X,Y ARRAYS
      NFOUND=NFOUND+1
      if(idigits.eq.0) then
         write(labl,'(i8)') nint(cont(ic))
      else if(idigits.eq.1) then
         write(labl,'(f8.1)') cont(ic)
      else
         write(labl,'(f8.2)') cont(ic)
      end if
      if(lu.ne.0) then
         WRITE(LU,701) IC+IOFF,num,labl
701      FORMAT(2I5,1x,a)
         WRITE(LU,FORMAT) (X(J),Y(J),J=1,NUM)
      else
         call contpl(num,labl,8,1.,1.)
      end if
C********************************************************************** 
 900    CONTINUE
 1000   CONTINUE
        RETURN
        END 
C------------------------------------------------------------------
        SUBROUTINE GETXY(X,Y)
C          Given (LASTX,LASTY) as the lower left corner of a cell and
C          we have entered this cell along the LASTIN side;
C          Calculate the (X,Y) intersection with this cell.
C          Remember the (x,y) coordinate of (LASTX,LASTY) is:
C                        x=XMIN + (LASTX-1)*DXC
C                        y=YMIN + (LASTY-1)*DYC
C          Z in /GHPARMS/ is the contour level we are searching.
C          ZA(i) is the Z value at each index of this cell
      COMMON /GHPARMS/ Z,ZA(5),LASTX,LASTY,NEXTX,NEXTY,LASTIN,LASTOT  
        COMMON /RUNDATA/ XMIN,YMIN,DXC,DYC,NX,NY
        FRACT=.5
        DZ=ZA(LASTIN+1) - ZA(LASTIN) 
        IF(DZ.NE.0.0) FRACT=(Z-ZA(LASTIN))/DZ 
        GO TO (10,20,30,40),LASTIN
 10     FX=1.-FRACT
        FY=0. 
        GO TO 50
 20     FY=FRACT
        FX=0.
        GO TO 50
 30     FY=1. 
        FX=FRACT 
        GO TO 50
 40     FX=1.
        FY=1.-FRACT 
 50     Y=YMIN + DYC*(FY + FLOAT(LASTY-1)) 
        X=XMIN + DXC*(FX + FLOAT(LASTX-1))
        RETURN
        END 
C------------------------------------------------------------------
        FUNCTION NEXTPT(IDF,MASK,INLAST,NUM)
C          Given our current cell (LASTX,LASTY) going in LASTIN,
C          Find the next cell (NEXTX,NEXTY) and the way in it LASTOT.
        COMMON /GHPARMS/ Z,ZA(5),LASTX,LASTY,NEXTX,NEXTY,LASTIN,LASTOT  
        COMMON /RUNDATA/ XMIN,YMIN,DXC,DYC,NX,NY 
        NEXTPT=0
C          CHECK TO SEE IF WE ARE ON A BORDER GOING OUT 
        GO TO (10,20,30,40),LASTIN
 10     IF(LASTY.GE.NY) GO TO 300  
        GO TO 50
 20     IF(LASTX.GE.NX) GO TO 300
        GO TO 50
 30     IF(LASTY.EQ.0) GO TO 300 
        GO TO 50
 40     IF(LASTX.EQ.0) GO TO 300
 50     IF(IAND(IDF,MASK).EQ.0 .AND. IAND(IDF,LS(MASK,8)).EQ.0)RETURN
C          IS THIS A SPECIAL "RIDGE" CASE 
        IF((Z.LT.ZA(1) .AND. Z.LT.ZA(3) .AND. Z.GE.ZA(2) .AND.
     +     Z.GE.ZA(4)) .OR. (Z.LT.ZA(2) .AND. Z.LT.ZA(4)
     +     .AND. Z.GE.ZA(1) .AND. Z.GE.ZA(3))) GO TO 60 
        GO TO 90
CC         SPECIAL RIDGE/VALLEY CASE
 60     CALL RIDGE(Z,ZA,LASTIN,DXC,DYC,IWOUT)
        GO TO 150 
 90     DO 100 IWOUT=1,4
C          DO NOT GO OUT THE WAY WE CAME IN 
        IF(IWOUT.EQ.LASTIN) GO TO 100 
        ZLOW=AMIN1(ZA(IWOUT),ZA(IWOUT+1))
        ZHI =AMAX1(ZA(IWOUT),ZA(IWOUT+1))
        IF(ZLOW.LE.Z .AND. Z.LT.ZHI) GO TO 150
 100    CONTINUE
        STOP 'COULD NOT GET OUT OF BOX'
 150    NEXTPT=1
        IF(INLAST.EQ.0 .AND. NUM.EQ.1) GO TO 175
        IF(IAND(IDF,MASK).NE.0) GO TO 170 
C          THIS IS 2nd TIME WE HAVE COME IN AND GONE OUT OF BOX 
        IDF=IEOR(IDF,LS(MASK,8)) 
        GO TO 175 
C          1st TIME IN AND OUT OF BOX 
 170    IDF=IEOR(IDF,MASK)
 175    NEXTX=LASTX 
        NEXTY=LASTY 
C          GET LOWER LEFT CORNER OF NEXT BOX
        GO TO (210,220,230,240),IWOUT 
 210    NEXTY=NEXTY-1 
        LASTOT=3  
        RETURN
 220    NEXTX=NEXTX-1 
        LASTOT=4  
        RETURN
 230    NEXTY=NEXTY+1 
        LASTOT=1  
        RETURN
 240    NEXTX=NEXTX+1 
        LASTOT=2  
        RETURN
 300    NEXTPT=-1 
        RETURN
        END 
C------------------------------------------------------------------
        SUBROUTINE RIDGE(Z,ZA,LASTIN,DX,DY,IWOUT) 
C***********************************************************************
C          ORIGINAL RIDGE DECISION
C                  GREG HAND
C***********************************************************************
        DIMENSION ZA(*)
        IF(Z.LT.ZA(2) .AND. Z.LT.ZA(4)) GO TO 70
C          RIDGE IS 1-3 
        IWOUT=3-LASTIN
        IF(IWOUT.LE.0) IWOUT=IWOUT+4
        RETURN
C          RIDGE IS 2-4 
 70     IWOUT=5-LASTIN
        RETURN
        END 
