      subroutine wmap(map_only)
c******************************************************************
c          luc    = lu number of contour file
c******************************************************************
ccc      common /crun_directory/ run_directory
ccc         character run_directory*50
      common /c_printer_setup/ draw_border,scale_factor,Xoffset,Yoffset
         integer*4 draw_border      !  1=yes, 2=no
         real*4 scale_factor,Xoffset,Yoffset
      character xparameter*8
      common /c_wmap/ luc,xmin,xmax,ymin,ymax
      common /c_inpfile/ inpfile
         character inpfile*80
      common /c_menu_checks/ mode_color1,mode_color2,mode_BW,
     +                       mode_BW1,mode_BW2,mode_BW5
      common /textsize/ ichxx,ichyy
      INCLUDE <WINDOWS.INS>
      common /mdevice/ idev,ixoff,iyoff     !  =0=screen         =1=printer
      common /ipwindo/ itminvx,itminvy,itmaxvx,itmaxvy
      common /zminmax/ zmin,zmax,labels
      character labels*60
      common /csector/ isector,ideg1,ideg2,km1,km2
      common /crotate/ irot      !  1=rotate, 0=don't
      common /seg1c/ iseg1
      common /cons/ ncolor,con(200),jcolor(200)
      common /Cdigits/ idigits
      common /colors/ icolor(6)
      common /proj/ iproj,plat,plon
      common /projp/ w(4),nstep,isub,icont,jproj,polat,polong,rot,
     +               jlts,igrid,pl1(2),pl2(2),pl3(2),pl4(2)
      common /c_yscal/ yscal
      common /minmax/ umin,umax,vmin,vmax
      common /blok1/ dm1(2),idm1(2),ww(4),idm2(2),dm2(8)
      common /lu/ luin,lut,lup
      common /modelc/ model
      character model*6,color*1,map_only*1
      character raster*20,label*80,lfile*20,ifile*80
      dimension icitycolor(6)
      dimension ishades(16)
      data ishades/0,58,6,51,5,8,12,18,19,20,21,22,55,56,57,59/
c                    black  red  blue
      data icitycolor/0,0  ,1,1  ,4,4/
      data label/'      '/
c********************************************************************
ccc      nch_run=lcount(run_directory,50)
      ifile=inpfile
c
      lfile=ifile(1:12)
      iworld=31                    !  plot whole world
      xparameter='        '
ccc      iproj=7                   !  azimuthal-equidistant projection
      w(1)=xmin
      w(2)=xmax
      w(3)=ymin
      w(4)=ymax
      if(iproj.eq.8) then    !  force projection center for Lat/Lon projection
         plat=0.
         plon=(xmin+xmax)/2.
         if(xmax-xmin.lt.355.) plon=0.
      end if
      if(luc.gt.0) then
         rewind(luc)
         read(luc,'(a)') lfile
         read(luc,'(a)') model
         read(luc,'(a)') xparameter
         read(luc,'(a)') label
         method=1
      else
         method=-1                 !  map only
         write(label,1) 
     +                  nint(xmin),nint(xmax),nint(ymin),nint(ymax)
1        format('X[',i6,1h,,i6,
     +          ']      Y[',i6,1h,,i6,1h])
      end if
c
ccc      call getlabl( 29,30,label,lfile,zmin,zmax)  !  get label and filename
ccc      if(zmin.ge.zmax) icolor(5)=-1   !  no .grd file
      iseg1=0
      call seg1                            !  auto setup
      call supmap(jproj,polat,polong,rot,pl1,pl2,pl3,pl4,jlts)
      umin=9999999.
      vmin=umin
      umax=-umin
      vmax=-vmin
      irot=0                    !  don't rotate plot
      if(iproj.ne.7) then
         if(ww(2)-ww(1).gt.350.) then
            ww(1)=-180.
            ww(2)= 180.
ccc            call setw(-360.,w(3),360.,w(4))
            call setw(-180.,w(3),180.,w(4))
         else
            call setw(w(1),w(3),w(2),w(4))
         end if
c            y-length           x-length
ccc   if((w(4)-w(3))*yscal .gt. w(2)-w(1)) irot=1
      end if
      if(iproj.eq.7) call setw(0.,0.,0.,0.)
c******************************************************************
c*****************************************************************
c     write(lut,'('' Zmin/Zmax='',2f10.3)') zmin,zmax
c     write(lut,'('' #contours, (contour,color)pairs = '',$)')
c     read(luin,*) ncolor,(con(i),jcolor(i),i=1,ncolor)
c     call defcon(zmin,zmax,con,ncolor)    !  get default levels
c******************************************************************
ccc      open(34,file='wmap.dmp')
ccc      rewind(34)
ccc      write(34,'('' Zmin/Zmax='',2f10.3)') zmin,zmax
ccc      write(34,'(i5,10f8.2)') ncolor,(con(i),i=1,ncolor)
ccc      write(34,'('' iproj='',i5)') iproj
ccc      write(34,'('' ww='',4f10.4)') ww
ccc      write(34,'('' w ='',4f10.4)') w
ccc      write(34,'('' polong='',f10.4)') polong
c******************************************************************
      call getsize(lenx,leny)     !  get screen size
      if(idev.eq.0) then
         call border(15)   !  do not draw border around plot area
ccc         call border( 0)   !  draw border around plot area
      else
         call clear_screen@!  erase screen for printer
         icol=-1           !  do not draw border
         if(draw_border.eq.1) icol=0    !  draw border
         call border(icol)
      end if
      ires=iresolut()              !  get screen resolution
      if(iproj.eq.7) then   !  GREAT CIRCLE projection
         call scalset(.040,.050)
         factx=.755         !  fraction of x usable
         facty=.825         !  fraction of y usable
         if(ires.eq.1) then
            factx=.700  !  smaller for 640x480 screen
            facty=.800
            call scalset(.050,.060)
         end if
         call scalexy(ww(1),ww(2),ww(3),ww(4),factx,facty)
      else if(iproj.eq.8) then  !  LAT/LON projection
         fact=.725
         fact=.775
         call scalset(.0875,.075)
         yscal=1.6
         call scale(ww(1),ww(2),ww(3),ww(4),fact,yscal)
      end if
      if(idev.eq.0) call mouse_set_scale    ! set scale factors for mouse picks
      dxscreen=ww(2)-ww(1)
ccc      call charget(chx,chy)
c******************************************************************
      if(map_only.eq.'m') go to 28     !  map only
c******************************************************************
c          icolor(6) = 0 = SHADE & BLACK contours
c                    = 1 = SHADE & RED   contours
c                    = 2 =         BLACK contours
c                    = 3 =         RED   contours
c                    = 4 = SHADE &  no   contours
c                    = 5 = BIN COLOR SHADING
c                    = 6 = BIN Black/White SHADING
      kolor=icolor(6)
      if(kolor.eq.0 .or. kolor.eq.1 .or. kolor.ge.4) then
ccc         call scolor(icolor(6))
ccc         call setext(7,1,0,ichx,ichy)     !  VGA FIXED text,  0 deg
         if(kolor.eq.5) then
ccc            call shadebin                    !  BIN color shading
         else if(kolor.eq.6) then
ccc            open(21,file=run_directory(1:nch_run-3)//
            open(21,file=
     +           'database\shades.def',status='old',err=20)
            rewind(21)
            do 10 i=1,16
10          read(21,11) ishades(i)
11          format(2x,i2)
            close(21)
20          continue
            do 25 i=1,ncolor
25          jcolor(i)=ishades(jcolor(i)+1)
            call shadebw                     !  BIN black/white shading
         else
c                   shade contour levels for screen
            if(idev.ne.1 .and. mode_color1.eq.1) call shade
            if(idev.ne.1 .and. mode_color2.eq.1) call shade
         end if
      end if
      call ghcur       !  update display
c******************************************************************
28    if(icolor(1).ge.0 .and. igrid.ne.0) then    !  plot grid layer
          call scolor(icolor(1))
          if(ires.eq.1) then           !  640x480 screen
             size=.85
          else if(ires.eq.2) then      !  800x600 screen
             size=.65
          else if(ires.eq.3) then      !  1024x768 screen
             size=.7
          else if(ires.le.-600) then      ! high resolution printer
             size=.4
          else
             size=.5
          end if
          call setext(3,size,0.,0.,ichx,ichy)
cxxx          call setext(7,1,0,ichx,ichy)     !  VGA FIXED text,  0 deg
cxxx          chy=ichy
          if(iproj.eq.8) call sgrid(size)
      else
cxxx         call setext(7,1,0,ichx,ichy)     !  VGA FIXED text,  0 deg
cxxx         call scolor(0)            !  no grid, draw frame anyway
cxxx         call jclpw(0)             !  turn off clipping
cxxx         call frame(ww(1),ww(2),ww(3),ww(4))
cxxx         call jclpw(1)             !  turn on clipping
      end if
c******************************************************************
ccc      if(icolor(5).ge.0) then      !  antenna main beam
ccc         call scolor(icolor(5))
ccc         do 30 i=1,nant
ccc         call setext(3,size,0.,0.,ichx,ichy)
ccc30       call sbear(tlat(i),tlon(i),bear(i))
ccc      end if
c******************************************************************
c          icolor(6) = 0 = SHADE & BLACK contours
c                    = 1 = SHADE & RED   contours
c                    = 2 =         BLACK contours
c                    = 3 =         RED   contours
c                    = 4 = SHADE &  no   contours
c                    = 5 = BIN COLOR SHADING
c                    = 6 = BIN Black/White SHADING
      kolor=icolor(6)
      if(mode_color2.eq.1) kolor=4    !  shade NO contours
      if(kolor.gt.1) kolor=kolor-2
      if(luc.gt.0 .and. (kolor.eq.0 .or. kolor.eq.1)) then
         call scolor(kolor)
         if(ires.eq.1) then           !  640x480 screen
            size=.85
         else if(ires.eq.2) then      !  800x600 screen
            size=.825
         else if(ires.le.-600) then      !  high resolution printer
            size=.5
         else
            size=.6
         end if
            call setext(4,size,0.,0.,ichx,ichy)
         if(idev.ne.0) then
            call set_line_width@(4)      !  printer thickness
ccc            if(ires.le.-600) call set_line_width@(8)
         else
            call set_line_width@(2)      !  screen thickness
         end if
         call boxpl(luc)        !  plot contours
         call set_line_width@(1)      !  original line thickness
         call ghcur
      end if
c******************************************************************
      
c******************************************************************
c          plot world if requested
      if(icolor(2).ge.0 .and. iworld.ne.0) then
         call scolor(icolor(2))
         call world(w(1),w(2),w(3),w(4),nstep,iworld,iproj) ! plot world
      end if
c******************************************************************
      if(map_only.ne.'m') then
         color='C'
         if(icolor(6).eq.2 .or. icolor(6).eq.3) color='B'   !  non-shaded
         if(icolor(6).eq.6) color='S'   !  Black/White shaded
         if(idev.eq.1) color='B'        !  black/white laserjet
         if(mode_color1+mode_color2.ne.1) color='B'  !  black/white screen
         call plotxy(ww(2),ww(4),u,v)
         call legend(xparameter,labels,color,model,u,v,
     +               ncolor,con,jcolor,zmin,zmax,idigits)
      end if
c******************************************************************
      call scolor(0)                   !  always label with black
ccc      write(*,'(''model='',a)') model
ccc      write(*,'(''map_only='',a)') map_only
ccc      write(*,'(''label='',a)') label
      call slabl(model,map_only,label,lfile,xparameter)
      call ghcur
c******************************************************************
      raster=ifile(1:12)
      call suffix(raster,12,'.scr',4)
      if(method.eq.1) raster=lfile      !  use data file name
cxxx      call dumpraster(raster)   !  dump raster image to disk file
      raster='worldmap.plt'     !  also save on file WORLDMAP.PLT
      nch=lcount(lfile,12)
      if(method.eq.1) raster(12:12)=lfile(nch-1:nch-1)
      call jmcur
ccc      close(34)
      return
      end
c------------------------------------------------------------------
